
-- theres your taunt
-- -Pacola
-- thanks
-- -Sunflower

freeslot("S_PESKY_TAUNT","sfx_pmt")

local spr2 = SPR2_CLMB -- PLEASE freeslot whatever sprite2 you use here

states[S_PESKY_TAUNT] = {
	sprite = SPR_PLAY,
	frame = spr2,
	tics = -1,
	nextstate = S_PESKY_TAUNT
}

local function canTaunt(p)
	if P_PlayerInPain(p)
	or p.playerstate == PST_DEAD
		return false
	end
	return true
end

addHook("PlayerSpawn", function(p)
	p.pptaunting = false
end)

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "peskymario"
		if p.pptaunting
			p.pptaunting = false
		end
		return
	end
	
	if (p.cmd.buttons & BT_TOSSFLAG) -- chang the BT_ thing for another buton
		p.pptauntheld = $+1
	else
		p.pptauntheld = 0
	end
	
	if p.pptauntheld == 1
	and not p.pptaunting -- pp is pespky plumbe :D
	and canTaunt(p)
		p.pptaunt = {
			time = 0,
			momx = p.mo.momx,
			momy = p.mo.momy,
			momz = p.mo.momz,
			state = p.mo.state,
			anim_dur = p.mo.anim_duration,
			tics = p.mo.tics,
			frame = p.mo.frame,
			tframe = P_RandomRange(0, skins[p.mo.skin].sprites[spr2].numframes-1)
		}
		p.pptaunting = true
		S_StartSound(p.mo, sfx_pmt) -- replac sfx_thok with sound you want play :)
	end
	
	if p.pptaunting
		if not canTaunt(p)
			p.pptaunting = false
			return
		end
		local t = p.pptaunt
		p.pflags = $1|PF_FULLSTASIS
		p.mo.momx = 0
		p.mo.momy = 0
		p.mo.momz = 0
		
		if p.mo.state ~= S_PESKY_TAUNT
			p.mo.state = S_PESKY_TAUNT
			p.mo.frame = t.tframe
		end
		
		t.time = $+1
		if t.time >= TICRATE/2 -- change this value for another time thing i dont know
			p.pptaunting = false
			p.mo.momx = t.momx
			p.mo.momy = t.momy
			p.mo.momz = t.momz
			P_MovePlayer(p)
			p.mo.state = t.state
			p.mo.anim_duration = t.anim_dur
			p.mo.tics = t.tics
			p.mo.frame = t.frame
			return
		end
	end
end)